/* Verschlsselung von ausgehenden Mails in PMMail 
   Geschrieben von Carsten Arnold <C.Arnold@Transnet.de>

   Wenn fr einen Adressaten kein PubKey vorhanden ist, wird die Mail nicht verschlsselt.
   Wenn  die Nachricht bereits verschlsselt ist, wird nicht nochmal verschlsselt.

   Das Script kann als Filter in PMMail eingesetzt werden, um an bestimmte Adressen
   die Mails immer verschlsselt zu senden, ohne, da man selber daran denken mu. :-)

   ACHTUNG, sollen signierte Mails verschlsselt werden, ist das Mantra erforderlich.
   Dieses mu der Variablen 'Mantra' zur Verfgung gestellt werden.
   Enthlt die Variable '',  wird das Mantra abgefragt.
   Da aber das Script i.d.R. im Hintergrund luft, kann es passieren, da man das nicht merkt.
   Dan Mantra kann natrlich auf "fest" codiert werde, was allerdings nicht sehr ratsam ist.
   Mglich ist auch, das Mantra in einer Datei aufszubewaren.
   siehe "Mantra = linein( 'Mantra.pgp' )"
   Dabei ist Mantra.pgp der Dateiname.
*/

call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs

Mantra  = ''
Mantra = linein( 'Mantra.pgp' )

parse arg File

Punkt = lastpos( '.', File )
Body  = substr( File, 1, Punkt ) || 'x$x'           /* Dateiname fr Bodydatei bilden */
Crypt = substr( File, 1, Punkt ) || 'asc'           /* Name der verschlsselten Datei */
Target= substr( File, 1, Punkt ) || 't$t'           /* Zieldatei */
Slash = lastpos( '\', File )
Bag   = substr( File, 1, Slash ) || 'FOLDER.BAG'    /* Name der Datei FOLDER.BAG */
Bag1  = substr( File, 1, Slash ) || 'FOLDER.BA$'    /* temp. FOLDER.BAG */
FileName = substr( File, Slash+1 )                  /* Dateiname der MSg-Datei ohne Pfad */

/* Header durchsuchen */
User.0  = 0
UserCount = 0
Multi = ''
 
rc = stream( File, 'c', 'open' )
do while lines( File )
   Zeile = linein( File )
   if Pos( 'To:', Zeile )==1 | Pos( 'Cc:', Zeile )==1 | Pos( 'Bcc:', Zeile )==1 | Pos( 'From:', Zeile )==1 then
   do 
      Komma = ','
      do while Komma==',' 
         User = substr( Zeile, pos( '<', Zeile )+1 ) 
         Komma = substr( User, length( User ), 1 )
         User = strip( User, , ',' )
         User = strip( User, , '>' )
         User = translate( User )
         do i=1 to UserCount                            /* Dopplungen von Usern vermeiden */
            if compare( User.i, User )==0 then leave
         end /* do */
         if compare( User.i, User )<>0 then
         do 
            UserCount = UserCount + 1
            User.UserCount = User
         end /* do */
         if Komma==',' then
            Zeile = linein( File )
      end /* do */
   end /* do */
   if Pos( 'Content-Type: multipart/mixed', Zeile )==1 then
      do 
         Multi = substr( Zeile, pos( '="', Zeile )+1 )
         Multi = strip( Multi, , '"' )
      end /* do */
   if length( Zeile )<1 then        /* Leerzeile, jetzt beginnt der Body */
      leave
end /* do */
User.0 = UserCount

/* berprfung ob alle User im PubRing enthalten sind */
'@echo off'
do i=1 to User.0
   'pgp -kv ' User.i ' >nul 2>>&1'
   if rc==0 then say 'User:   ' User.i ' OK'
   else say 'User:   ' User.i ' nicht gefunden'
   
   if rc>0 then
   do 
      say ''
      call beep 2000, 500
      say 'Die Nachricht kann nicht fr den User 'User.i 
      say 'verschlsselt werden. Die Verschlsselung wird unterbunden.'
      call beep 2000, 500
      return rc
   end /* do */
end /* do */

Signed = ''
/* nach Beginn der Verschlsselung suchen */
do while lines( File )
   pgp = linein( File )
   if Pos( '-----BEGIN PGP MESSAGE-----', pgp ) then
      do 
         say 'Nachricht ist bereits verschlsselt'
         return 0
      end /* do */
   if Pos( '-----BEGIN PGP SIGNED MESSAGE-----', pgp ) then Signed = '-----BEGIN PGP SIGNATURE-----'
end /* do */

/* Body suchen und nach Target schreiben */
Zeile = linein( File, 1, 0 )
call SysFileDelete Target
do while lines( File )
   Zeile = linein( File )
   if length( Zeile )==0 then
   do    
      call lineout Target, 'X-Encrypter: Encrypt.cmd by C.Arnold v1.1'
      call lineout Target, ''
      leave
   end /* do */
   call lineout Target, Zeile
end /* do */

/* Multipart Message */
if Multi<>'' then
do 
   do while lines( File )
      Zeile = linein( File )
      call lineout Target, Zeile
      if pos( Multi, Zeile )>0 then     /* Multi-String suchen und kopieren */
      do 
         do while lines( File )
            Zeile = linein( File )
            call lineout Target, Zeile
            if length( Zeile )==0 then
               leave
         end /* do */
      end /* do */
      if length( Zeile )==0 then
         leave
   end /* do */
end /* do */

if Signed<>'' then
do 
   do while pos( '-----BEGIN PGP SIGNED MESSAGE-----', Zeile )==0 & lines( File )
      Zeile = linein( File )
   end /* do */
   Zeile = linein( File )
end /* do */

call SysFileDelete Body
rc = stream( Body, 'c', 'open' )             /* Body nach Bodydatei kopieren */
do while lines( File )
   Zeile = linein( File )
   if Multi<>'' & pos( Multi, Zeile )>0 then
      leave
   if Signed<>'' & pos( Signed, Zeile)>0 then
   do                                           
      do while lines( File )                /* Beginn des Attachments suchen */
         Zeile = linein( File )
         if Multi<>'' & pos( Multi, Zeile )>0 then
            leave
      end /* do */
      leave
   end /* do */
   rc = lineout( Body, Zeile )
end /* do */
rc = stream( Body, 'c', 'close' )           /* Body ist fertig kopiert */

call SysFileDelete 'User'   /* Platz machen fr User */
User = User.1               /* Alle User in Datei User Schreiben */
rc = lineout( 'User', User.1 )
do i=2 to User.0
   rc = lineout( 'User', User.i )
end /* do */
rc = stream( 'User', 'c', 'close' )
User = '-@ User'

call SysFileDelete Crypt                    /* Platz machen fr Zieldatei */

if Signed<>'' then 
do 
   if Mantra=='' then
   do 
      Count = 0
      Zahl = 0
      say ''
      say 'Die Mail soll signiert werden'
      say 'Bitte geben Sie Ihr Mantra ein (Backspace ist mglich)'
      call Beep 1000, 500
      do while Zahl<>13
         Char = SysGetKey( 'noecho' )
         if c2d( Char )=224 | c2d( Char )=0 then Char = SysGetKey( 'noecho' )
         else
         do 
            Zahl = c2d( Char )
            if Zahl<32 then
            do 
               select;
               when Zahl==13 then 
               do 
                  if Count==0 then
                  do 
                     say 'Bitte geben Sie Ihr Mantra ein'
                     Zahl = 0;
                  end /* do */
                  else
                  say 'Danke'
               end /* do */
               when Zahl==8  then 
               do 
                  if Count>0 then
                  do 
                     Count = Count-1
                     Mantra = substr( Mantra, 1, Count )
                  end /* do */
                  else
                     call Beep 1000, 50
               end /* do */
               otherwise
               end;
            end /* do */
            else
            do 
               Count = Count + 1
               Mantra = overlay( Char, Mantra, Count )
            end /* do */
         end /* do */
      end /* do */

   end /* do */
   'pgp -sea 'Body User '"-z'Mantra'"' ' +batchmode >nul 2>>&1 ' 
end /* do */
else
   'pgp -ea 'Body User '+batchmode >nul 2>>&1 '

if rc>0 & Signed<>'' then                           /* Mantra war mglicherweise falsch oder nicht vorhanden */
do 
   call Beep 1000, 50
   say 'Die Mail konnte nicht signiert werden, '
   say 'es wird versucht sie wenigstens zu verschlsseln'
   'pgp -ea 'Body User '+batchmode >nul 2>>&1 '     /* darum, wenigstens ohne Signatur verschlsseln */
end /* do */

call SysFileDelete Body                  /* lsche Body */
call SysFileDelete 'User'

if rc>0 then
do 
   say 'Fehler 'rc' bei Verschlsselung'
   exit
end /* do */

rc = stream( Crypt, 'c', 'open' )
do while lines( Crypt )                   /* kopiere verchlsselte Datei in den Body */
   rc = lineout( Target, linein( Crypt ) )
end /* do */

rc = stream( Crypt, 'c', 'close' )
call SysFileDelete Crypt                  /* verschlsselte Datei */

rc = lineout( Target, '' )

rc = lineout( Target, Zeile )
do while lines( File )                   /* Rest der Datei kopieren */
   Zeile = linein( File )
   rc = lineout( Target, Zeile )
end /* do */
rc = stream( File, 'c', 'close' )
rc = stream( Target, 'c', 'close' )
call SysFileDelete File
'ren ' Target FileName

/* versuche FOLDER.BAG zu korrigieren, damit PMMail das verschlsselungssymbol anzeigt
   hat aber anscheinend keine Wirkung, PMMail berschreibt die Datei spter wieder. */

rc = stream( Bag, 'c', 'open' )
do while lines( Bag )
   Zeile = linein( Bag )
   if Pos( FileName, Zeile )>0 then
   do 
     if Multi='' then Zeile = overlay( '2', Zeile, 3 )
     else Zeile = overlay( '3', Zeile, 3 )
   end /* do */
   rc = lineout( Bag1, Zeile )
end /* do */
rc = stream( Bag, 'c', 'close' )
rc = stream( Bag1, 'c', 'close' )

call SysFileDelete Bag
'ren 'Bag1 substr( Bag, lastpos( '\', Bag )+1 )

return rc

Enter:
parse arg Text

if Text='' then Text = 'Taste drcken'

say Text
rc = SysGetKey( 'noecho' )
return rc

